Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/libyahoo2.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -2561,5 +2091,5 @@
 	long tm = 0L;
 	int state = YAHOO_STATUS_AVAILABLE;
-	int online = FALSE;
+	int online = 0;
 	int away = 0;
 	int idle = 0;
@@ -2590,16 +2120,19 @@
 		else if (pair->key == 60)
 			mobile = strtol(pair->value, NULL, 10);
-		
+
 	}
 
 	if (id)
-		YAHOO_CALLBACK(ext_yahoo_contact_added)(yd->client_id, id, who, msg);
+		YAHOO_CALLBACK(ext_yahoo_contact_added) (yd->client_id, id, who,
+			msg);
 	else if (name)
-		YAHOO_CALLBACK(ext_yahoo_status_changed)(yd->client_id, name, state, msg, away, idle, mobile);
-	else if(pkt->status == 0x07)
-		YAHOO_CALLBACK(ext_yahoo_rejected)(yd->client_id, who, msg);
-}
-
-static void yahoo_process_buddyadd(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		YAHOO_CALLBACK(ext_yahoo_status_changed) (yd->client_id, name,
+			state, msg, away, idle, mobile);
+	else if (pkt->status == 0x07)
+		YAHOO_CALLBACK(ext_yahoo_rejected) (yd->client_id, who, msg);
+}
+
+static void yahoo_process_buddyadd(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2609,5 +2142,5 @@
 	char *me = NULL;
 
-	struct yahoo_buddy *bud=NULL;
+	struct yahoo_buddy *bud = NULL;
 
 	YList *l;
@@ -2624,49 +2157,28 @@
 	}
 
-	yahoo_dump_unhandled(pkt);
-
-	if(!who)
-		return;
-	if(!where)
+	if (!who)
+		return;
+	if (!where)
 		where = "Unknown";
 
-	/* status: 0 == Successful, 1 == Error (does not exist), 2 == Already in list */
-	if( status == 0 ) {
-		bud = y_new0(struct yahoo_buddy, 1);
-		bud->id = strdup(who);
-		bud->group = strdup(where);
-		bud->real_name = NULL;
-		
-		yd->buddies = y_list_append(yd->buddies, bud);
-	
-		/* Possibly called already, but at least the call above doesn't
-		   seem to happen every time (not anytime I tried). */
-		YAHOO_CALLBACK(ext_yahoo_contact_added)(yd->client_id, me, who, NULL);
-	}
-
-/*	YAHOO_CALLBACK(ext_yahoo_status_changed)(yd->client_id, who, status, NULL, (status==YAHOO_STATUS_AVAILABLE?0:1)); */
-}
-
-static void yahoo_process_contact_ymsg13(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
-{
-	char* who=NULL;
-	char* me=NULL;	
-	char* msg=NULL;
-	YList *l;
-	for (l = pkt->hash; l; l = l->next) {
-		struct yahoo_pair *pair = l->data;
-		if (pair->key == 4)
-			who = pair->value;
-		else if (pair->key == 5)
-			me = pair->value;
-		else
-			DEBUG_MSG(("unknown key: %d = %s", pair->key, pair->value));
-	}
-
-	if(pkt->status==3)
-		YAHOO_CALLBACK(ext_yahoo_contact_auth_request)(yid->yd->client_id, me, who, msg);
-}
-
-static void yahoo_process_buddydel(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	bud = y_new0(struct yahoo_buddy, 1);
+	bud->id = strdup(who);
+	bud->group = strdup(where);
+	bud->real_name = NULL;
+
+	yd->buddies = y_list_append(yd->buddies, bud);
+
+	/* A non-zero status (i've seen 2) seems to mean the buddy is already 
+	 * added and is online */
+	if (status) {
+		LOG(("Setting online see packet for info"));
+		yahoo_dump_unhandled(pkt);
+		YAHOO_CALLBACK(ext_yahoo_status_changed) (yd->client_id, who,
+			YAHOO_STATUS_AVAILABLE, NULL, 0, 0, 0);
+	}
+}
+
+static void yahoo_process_buddydel(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	struct yahoo_data *yd = yid->yd;
@@ -2691,10 +2203,11 @@
 			unk_66 = strtol(pair->value, NULL, 10);
 		else
-			DEBUG_MSG(("unknown key: %d = %s", pair->key, pair->value));
-	}
-
-	if(!who || !where)
-		return;
-	
+			DEBUG_MSG(("unknown key: %d = %s", pair->key,
+					pair->value));
+	}
+
+	if (!who || !where)
+		return;
+
 	bud = y_new0(struct yahoo_buddy, 1);
 	bud->id = strdup(who);
@@ -2707,5 +2220,5 @@
 	FREE(bud);
 
-	if(buddy) {
+	if (buddy) {
 		bud = buddy->data;
 		yd->buddies = y_list_remove_link(yd->buddies, buddy);
@@ -2717,14 +2230,15 @@
 		FREE(bud);
 
-		bud=NULL;
-	}
-}
-
-static void yahoo_process_ignore(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+		bud = NULL;
+	}
+}
+
+static void yahoo_process_ignore(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *who = NULL;
-	int  status = 0;
+	int status = 0;
 	char *me = NULL;
-	int  un_ignore = 0;
+	int un_ignore = 0;
 
 	YList *l;
@@ -2735,25 +2249,25 @@
 		if (pair->key == 1)
 			me = pair->value;
-		if (pair->key == 13) /* 1 == ignore, 2 == unignore */ 
+		if (pair->key == 13)	/* 1 == ignore, 2 == unignore */
 			un_ignore = strtol(pair->value, NULL, 10);
-		if (pair->key == 66) 
+		if (pair->key == 66)
 			status = strtol(pair->value, NULL, 10);
 	}
-
 
 	/*
 	 * status
-	 * 	0  - ok
-	 * 	2  - already in ignore list, could not add
-	 * 	3  - not in ignore list, could not delete
-	 * 	12 - is a buddy, could not add
+	 *      0  - ok
+	 *      2  - already in ignore list, could not add
+	 *      3  - not in ignore list, could not delete
+	 *      12 - is a buddy, could not add
 	 */
 
 /*	if(status)
 		YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, who, 0, status);
-*/	
-}
-
-static void yahoo_process_voicechat(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+*/
+}
+
+static void yahoo_process_voicechat(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *who = NULL;
@@ -2770,10 +2284,11 @@
 			me = pair->value;
 		if (pair->key == 13)
-			voice_room=pair->value;
-		if (pair->key == 57) 
-			room=pair->value;
-	}
-
-	NOTICE(("got voice chat invite from %s in %s to identity %s", who, room, me));
+			voice_room = pair->value;
+		if (pair->key == 57)
+			room = pair->value;
+	}
+
+	NOTICE(("got voice chat invite from %s in %s to identity %s", who, room,
+			me));
 	/* 
 	 * send: s:0 1:me 5:who 57:room 13:1
@@ -2787,8 +2302,9 @@
 }
 
-static void yahoo_process_ping(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_process_ping(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *errormsg = NULL;
-	
+
 	YList *l;
 	for (l = pkt->hash; l; l = l->next) {
@@ -2797,10 +2313,35 @@
 			errormsg = pair->value;
 	}
-	
+
 	NOTICE(("got ping packet"));
-	YAHOO_CALLBACK(ext_yahoo_got_ping)(yid->yd->client_id, errormsg);
-}
-
-static void _yahoo_webcam_get_server_connected(int fd, int error, void *d)
+	YAHOO_CALLBACK(ext_yahoo_got_ping) (yid->yd->client_id, errormsg);
+}
+
+static void yahoo_process_buddy_change_group(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	char *me = NULL;
+	char *who = NULL;
+	char *old_group = NULL;
+	char *new_group = NULL;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		if (pair->key == 1)
+			me = pair->value;
+		if (pair->key == 7)
+			who = pair->value;
+		if (pair->key == 224)
+			old_group = pair->value;
+		if (pair->key == 264)
+			new_group = pair->value;
+	}
+
+	YAHOO_CALLBACK(ext_yahoo_got_buddy_change_group) (yid->yd->client_id,
+		me, who, old_group, new_group);
+}
+
+static void _yahoo_webcam_get_server_connected(void *fd, int error, void *d)
 {
 	struct yahoo_input_data *yid = d;
@@ -2808,10 +2349,10 @@
 	char *data = NULL;
 	char *packet = NULL;
-	unsigned char magic_nr[] = {0, 1, 0};
+	unsigned char magic_nr[] = { 0, 1, 0 };
 	unsigned char header_len = 8;
 	unsigned int len = 0;
 	unsigned int pos = 0;
 
-	if(error || fd <= 0) {
+	if (error || !fd) {
 		FREE(who);
 		FREE(yid);
@@ -2821,5 +2362,5 @@
 	yid->fd = fd;
 	inputs = y_list_prepend(inputs, yid);
-	
+
 	/* send initial packet */
 	if (who)
@@ -2831,6 +2372,5 @@
 
 	/* send data */
-	if (who)
-	{
+	if (who) {
 		data = strdup("g=");
 		data = y_string_append(data, who);
@@ -2851,8 +2391,11 @@
 	FREE(data);
 
-	yid->read_tag=YAHOO_CALLBACK(ext_yahoo_add_handler)(yid->yd->client_id, fd, YAHOO_INPUT_READ, yid);
-}
-
-static void yahoo_webcam_get_server(struct yahoo_input_data *y, char *who, char *key)
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, fd,
+		YAHOO_INPUT_READ, yid);
+}
+
+static void yahoo_webcam_get_server(struct yahoo_input_data *y, char *who,
+	char *key)
 {
 	struct yahoo_input_data *yid = y_new0(struct yahoo_input_data, 1);
@@ -2862,15 +2405,17 @@
 	yid->yd = y->yd;
 	yid->wcm = y_new0(struct yahoo_webcam, 1);
-	yid->wcm->user = who?strdup(who):NULL;
-	yid->wcm->direction = who?YAHOO_WEBCAM_DOWNLOAD:YAHOO_WEBCAM_UPLOAD;
+	yid->wcm->user = who ? strdup(who) : NULL;
+	yid->wcm->direction = who ? YAHOO_WEBCAM_DOWNLOAD : YAHOO_WEBCAM_UPLOAD;
 	yid->wcm->key = strdup(key);
 
-	YAHOO_CALLBACK(ext_yahoo_connect_async)(yid->yd->client_id, yss->webcam_host, yss->webcam_port, 
-			_yahoo_webcam_get_server_connected, yid);
-
-}
-
-static YList *webcam_queue=NULL;
-static void yahoo_process_webcam_key(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+	YAHOO_CALLBACK(ext_yahoo_connect_async) (yid->yd->client_id,
+		yss->webcam_host, yss->webcam_port,
+		_yahoo_webcam_get_server_connected, yid, 0);
+
+}
+
+static YList *webcam_queue = NULL;
+static void yahoo_process_webcam_key(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	char *me = NULL;
@@ -2879,15 +2424,15 @@
 
 	YList *l;
-	// yahoo_dump_unhandled(pkt);
+	yahoo_dump_unhandled(pkt);
 	for (l = pkt->hash; l; l = l->next) {
 		struct yahoo_pair *pair = l->data;
 		if (pair->key == 5)
 			me = pair->value;
-		if (pair->key == 61) 
-			key=pair->value;
+		if (pair->key == 61)
+			key = pair->value;
 	}
 
 	l = webcam_queue;
-	if(!l)
+	if (!l)
 		return;
 	who = l->data;
@@ -2898,10 +2443,9 @@
 }
 
-static void yahoo_packet_process(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
+static void yahoo_packet_process(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
 {
 	DEBUG_MSG(("yahoo_packet_process: 0x%02x", pkt->service));
-	yahoo_dump_unhandled(pkt);
-	switch (pkt->service)
-	{
+	switch (pkt->service) {
 	case YAHOO_SERVICE_USERSTAT:
 	case YAHOO_SERVICE_LOGON:
@@ -2914,5 +2458,5 @@
 	case YAHOO_SERVICE_IDDEACT:
 	case YAHOO_SERVICE_Y6_STATUS_UPDATE:
-	case YAHOO_SERVICE_YMSG15_STATUS:
+	case YAHOO_SERVICE_Y8_STATUS:
 		yahoo_process_status(yid, pkt);
 		break;
@@ -2928,5 +2472,7 @@
 		yahoo_process_mail(yid, pkt);
 		break;
-	case YAHOO_SERVICE_REJECTCONTACT:
+	case YAHOO_SERVICE_Y7_AUTHORIZATION:
+		yahoo_process_new_contact(yid, pkt);
+		break;
 	case YAHOO_SERVICE_NEWCONTACT:
 		yahoo_process_contact(yid, pkt);
@@ -2963,12 +2509,15 @@
 		break;
 	case YAHOO_SERVICE_P2PFILEXFER:
-	case YAHOO_SERVICE_FILETRANSFER:
+	case YAHOO_SERVICE_Y7_FILETRANSFER:
 		yahoo_process_filetransfer(yid, pkt);
+		break;
+	case YAHOO_SERVICE_Y7_FILETRANSFERINFO:
+		yahoo_process_filetransferinfo(yid, pkt);
+		break;
+	case YAHOO_SERVICE_Y7_FILETRANSFERACCEPT:
+		yahoo_process_filetransferaccept(yid, pkt);
 		break;
 	case YAHOO_SERVICE_ADDBUDDY:
 		yahoo_process_buddyadd(yid, pkt);
-		break;
-	case YAHOO_SERVICE_CONTACT_YMSG13:
-		yahoo_process_contact_ymsg13(yid,pkt);
 		break;
 	case YAHOO_SERVICE_REMBUDDY:
@@ -2987,4 +2536,7 @@
 		yahoo_process_ping(yid, pkt);
 		break;
+	case YAHOO_SERVICE_Y7_CHANGE_GROUP:
+		yahoo_process_buddy_change_group(yid, pkt);
+		break;
 	case YAHOO_SERVICE_IDLE:
 	case YAHOO_SERVICE_MAILSTAT:
@@ -3000,4 +2552,5 @@
 	case YAHOO_SERVICE_CHATLOGOFF:
 	case YAHOO_SERVICE_CHATMSG:
+	case YAHOO_SERVICE_REJECTCONTACT:
 	case YAHOO_SERVICE_PEERTOPEER:
 		WARNING(("unhandled service 0x%02x", pkt->service));
@@ -3012,7 +2565,8 @@
 	case YAHOO_SERVICE_PICTURE_UPLOAD:
 		yahoo_process_picture_upload(yid, pkt);
-		break;	
-	case YAHOO_SERVICE_YMSG15_BUDDY_LIST:	/* Buddy List */
+		break;
+	case YAHOO_SERVICE_Y8_LIST:	/* Buddy List */
 		yahoo_process_buddy_list(yid, pkt);
+		break;
 	default:
 		WARNING(("unknown service 0x%02x", pkt->service));
@@ -3022,5 +2576,5 @@
 }
 
-static struct yahoo_packet * yahoo_getdata(struct yahoo_input_data * yid)
+static struct yahoo_packet *yahoo_getdata(struct yahoo_input_data *yid)
 {
 	struct yahoo_packet *pkt;
@@ -3029,5 +2583,5 @@
 	int pktlen;
 
-	if(!yd)
+	if (!yd)
 		return NULL;
 
@@ -3038,11 +2592,11 @@
 	}
 
-	pos += 4; /* YMSG */
+	pos += 4;		/* YMSG */
 	pos += 2;
 	pos += 2;
 
-	pktlen = yahoo_get16(yid->rxqueue + pos); pos += 2;
-	DEBUG_MSG(("%d bytes to read, rxlen is %d", 
-			pktlen, yid->rxlen));
+	pktlen = yahoo_get16(yid->rxqueue + pos);
+	pos += 2;
+	DEBUG_MSG(("%d bytes to read, rxlen is %d", pktlen, yid->rxlen));
 
 	if (yid->rxlen < (YAHOO_PACKET_HDRLEN + pktlen)) {
@@ -3056,9 +2610,12 @@
 	pkt = yahoo_packet_new(0, 0, 0);
 
-	pkt->service = yahoo_get16(yid->rxqueue + pos); pos += 2;
-	pkt->status = yahoo_get32(yid->rxqueue + pos); pos += 4;
+	pkt->service = yahoo_get16(yid->rxqueue + pos);
+	pos += 2;
+	pkt->status = yahoo_get32(yid->rxqueue + pos);
+	pos += 4;
 	DEBUG_MSG(("Yahoo Service: 0x%02x Status: %d", pkt->service,
-				pkt->status));
-	pkt->id = yahoo_get32(yid->rxqueue + pos); pos += 4;
+			pkt->status));
+	pkt->id = yahoo_get32(yid->rxqueue + pos);
+	pos += 4;
 
 	yd->session_id = pkt->id;
@@ -3068,10 +2625,11 @@
 	yid->rxlen -= YAHOO_PACKET_HDRLEN + pktlen;
 	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
-		unsigned char *tmp = y_memdup(yid->rxqueue + YAHOO_PACKET_HDRLEN 
-				+ pktlen, yid->rxlen);
+	if (yid->rxlen > 0) {
+		unsigned char *tmp = y_memdup(yid->rxqueue + YAHOO_PACKET_HDRLEN
+			+ pktlen, yid->rxlen);
 		FREE(yid->rxqueue);
 		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
+		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
 	} else {
 		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
@@ -3082,116 +2640,194 @@
 }
 
-static void yahoo_yab_read(struct yab *yab, unsigned char *d, int len)
+static struct yab *yahoo_yab_read(unsigned char *d, int len)
 {
 	char *st, *en;
 	char *data = (char *)d;
-	data[len]='\0';
+	struct yab *yab = NULL;
+
+	data[len] = '\0';
 
 	DEBUG_MSG(("Got yab: %s", data));
-	st = en = strstr(data, "userid=\"");
-	if(st) {
-		st += strlen("userid=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+	st = en = strstr(data, "e0=\"");
+	if (st) {
+		yab = y_new0(struct yab, 1);
+
+		st += strlen("e0=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->email = yahoo_xmldecode(st);
+	}
+
+	if (!en)
+		return NULL;
+
+	st = strstr(en, "id=\"");
+	if (st) {
+		st += strlen("id=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->yid = atoi(yahoo_xmldecode(st));
+	}
+
+	st = strstr(en, "fn=\"");
+	if (st) {
+		st += strlen("fn=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->fname = yahoo_xmldecode(st);
+	}
+
+	st = strstr(en, "ln=\"");
+	if (st) {
+		st += strlen("ln=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->lname = yahoo_xmldecode(st);
+	}
+
+	st = strstr(en, "nn=\"");
+	if (st) {
+		st += strlen("nn=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
+		yab->nname = yahoo_xmldecode(st);
+	}
+
+	st = strstr(en, "yi=\"");
+	if (st) {
+		st += strlen("yi=\"");
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->id = yahoo_xmldecode(st);
 	}
 
-	st = strstr(en, "fname=\"");
-	if(st) {
-		st += strlen("fname=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->fname = yahoo_xmldecode(st);
-	}
-
-	st = strstr(en, "lname=\"");
-	if(st) {
-		st += strlen("lname=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->lname = yahoo_xmldecode(st);
-	}
-
-	st = strstr(en, "nname=\"");
-	if(st) {
-		st += strlen("nname=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->nname = yahoo_xmldecode(st);
-	}
-
-	st = strstr(en, "email=\"");
-	if(st) {
-		st += strlen("email=\"");
-		en = strchr(st, '"'); *en++ = '\0';
-		yab->email = yahoo_xmldecode(st);
-	}
-
 	st = strstr(en, "hphone=\"");
-	if(st) {
+	if (st) {
 		st += strlen("hphone=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->hphone = yahoo_xmldecode(st);
 	}
 
 	st = strstr(en, "wphone=\"");
-	if(st) {
+	if (st) {
 		st += strlen("wphone=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->wphone = yahoo_xmldecode(st);
 	}
 
 	st = strstr(en, "mphone=\"");
-	if(st) {
+	if (st) {
 		st += strlen("mphone=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->mphone = yahoo_xmldecode(st);
 	}
 
 	st = strstr(en, "dbid=\"");
-	if(st) {
+	if (st) {
 		st += strlen("dbid=\"");
-		en = strchr(st, '"'); *en++ = '\0';
+		en = strchr(st, '"');
+		*en++ = '\0';
 		yab->dbid = atoi(st);
 	}
-}
-
-static struct yab * yahoo_getyab(struct yahoo_input_data *yid)
+
+	return yab;
+}
+
+static struct yab *yahoo_getyab(struct yahoo_input_data *yid)
 {
 	struct yab *yab = NULL;
-	int pos = 0, end=0;
+	int pos = 0, end = 0;
 	struct yahoo_data *yd = yid->yd;
 
-	if(!yd)
+	if (!yd)
 		return NULL;
 
+	do {
+		DEBUG_MSG(("rxlen is %d", yid->rxlen));
+
+		if (yid->rxlen <= strlen("<ct"))
+			return NULL;
+
+		/* start with <ct */
+		while (pos < yid->rxlen - strlen("<ct") + 1
+			&& memcmp(yid->rxqueue + pos, "<ct", strlen("<ct")))
+			pos++;
+
+		if (pos >= yid->rxlen - 1)
+			return NULL;
+
+		end = pos + 2;
+		/* end with > */
+		while (end < yid->rxlen - strlen(">")
+			&& memcmp(yid->rxqueue + end, ">", strlen(">")))
+			end++;
+
+		if (end >= yid->rxlen - 1)
+			return NULL;
+
+		yab = yahoo_yab_read(yid->rxqueue + pos, end + 2 - pos);
+
+		yid->rxlen -= end + 1;
+		DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
+		if (yid->rxlen > 0) {
+			unsigned char *tmp =
+				y_memdup(yid->rxqueue + end + 1, yid->rxlen);
+			FREE(yid->rxqueue);
+			yid->rxqueue = tmp;
+			DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+					yid->rxqueue));
+		} else {
+			DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
+			FREE(yid->rxqueue);
+		}
+
+	} while (!yab && end < yid->rxlen - 1);
+
+	return yab;
+}
+
+static char *yahoo_getwebcam_master(struct yahoo_input_data *yid)
+{
+	unsigned int pos = 0;
+	unsigned int len = 0;
+	unsigned int status = 0;
+	char *server = NULL;
+	struct yahoo_data *yd = yid->yd;
+
+	if (!yid || !yd)
+		return NULL;
+
 	DEBUG_MSG(("rxlen is %d", yid->rxlen));
 
-	if(yid->rxlen <= strlen("<record"))
+	len = yid->rxqueue[pos++];
+	if (yid->rxlen < len)
 		return NULL;
 
-	/* start with <record */
-	while(pos < yid->rxlen-strlen("<record")+1 
-			&& memcmp(yid->rxqueue + pos, "<record", strlen("<record")))
-		pos++;
-
-	if(pos >= yid->rxlen-1)
-		return NULL;
-
-	end = pos+2;
-	/* end with /> */
-	while(end < yid->rxlen-strlen("/>")+1 && memcmp(yid->rxqueue + end, "/>", strlen("/>")))
-		end++;
-
-	if(end >= yid->rxlen-1)
-		return NULL;
-
-	yab = y_new0(struct yab, 1);
-	yahoo_yab_read(yab, yid->rxqueue + pos, end+2-pos);
-	
-
-	yid->rxlen -= end+1;
+	/* extract status (0 = ok, 6 = webcam not online) */
+	status = yid->rxqueue[pos++];
+
+	if (status == 0) {
+		pos += 2;	/* skip next 2 bytes */
+		server = y_memdup(yid->rxqueue + pos, 16);
+		pos += 16;
+	} else if (status == 6) {
+		YAHOO_CALLBACK(ext_yahoo_webcam_closed)
+			(yd->client_id, yid->wcm->user, 4);
+	}
+
+	/* skip rest of the data */
+
+	yid->rxlen -= len;
 	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
-		unsigned char *tmp = y_memdup(yid->rxqueue + end + 1, yid->rxlen);
+	if (yid->rxlen > 0) {
+		unsigned char *tmp = y_memdup(yid->rxqueue + pos, yid->rxlen);
 		FREE(yid->rxqueue);
 		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
+		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
 	} else {
 		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
@@ -3199,88 +2835,36 @@
 	}
 
-
-	return yab;
-}
-
-static char * yahoo_getwebcam_master(struct yahoo_input_data *yid)
-{
-	unsigned int pos=0;
-	unsigned int len=0;
-	unsigned int status=0;
-	char *server=NULL;
+	return server;
+}
+
+static int yahoo_get_webcam_data(struct yahoo_input_data *yid)
+{
+	unsigned char reason = 0;
+	unsigned int pos = 0;
+	unsigned int begin = 0;
+	unsigned int end = 0;
+	unsigned int closed = 0;
+	unsigned char header_len = 0;
+	char *who;
+	int connect = 0;
 	struct yahoo_data *yd = yid->yd;
 
-	if(!yid || !yd)
-		return NULL;
+	if (!yd)
+		return -1;
+
+	if (!yid->wcm || !yid->wcd || !yid->rxlen)
+		return -1;
 
 	DEBUG_MSG(("rxlen is %d", yid->rxlen));
 
-	len = yid->rxqueue[pos++];
-	if (yid->rxlen < len)
-		return NULL;
-
-	/* extract status (0 = ok, 6 = webcam not online) */
-	status = yid->rxqueue[pos++];
-
-	if (status == 0)
-	{
-		pos += 2; /* skip next 2 bytes */
-		server =  y_memdup(yid->rxqueue+pos, 16);
-		pos += 16;
-	}
-	else if (status == 6)
-	{
-		YAHOO_CALLBACK(ext_yahoo_webcam_closed)
-			(yd->client_id, yid->wcm->user, 4);
-	}
-
-	/* skip rest of the data */
-
-	yid->rxlen -= len;
-	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
-		unsigned char *tmp = y_memdup(yid->rxqueue + pos, yid->rxlen);
-		FREE(yid->rxqueue);
-		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	} else {
-		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
-		FREE(yid->rxqueue);
-	}
-
-	return server;
-}
-
-static int yahoo_get_webcam_data(struct yahoo_input_data *yid)
-{
-	unsigned char reason=0;
-	unsigned int pos=0;
-	unsigned int begin=0;
-	unsigned int end=0;
-	unsigned int closed=0;
-	unsigned char header_len=0;
-	char *who;
-	int connect=0;
-	struct yahoo_data *yd = yid->yd;
-
-	if(!yd)
-		return -1;
-
-	if(!yid->wcm || !yid->wcd || !yid->rxlen)
-		return -1;
-
-	DEBUG_MSG(("rxlen is %d", yid->rxlen));
-
 	/* if we are not reading part of image then read header */
-	if (!yid->wcd->to_read)
-	{
-		header_len=yid->rxqueue[pos++];
-		yid->wcd->packet_type=0;
+	if (!yid->wcd->to_read) {
+		header_len = yid->rxqueue[pos++];
+		yid->wcd->packet_type = 0;
 
 		if (yid->rxlen < header_len)
 			return 0;
 
-		if (header_len >= 8)
-		{
+		if (header_len >= 8) {
 			reason = yid->rxqueue[pos++];
 			/* next 2 bytes should always be 05 00 */
@@ -3290,6 +2874,5 @@
 			yid->wcd->to_read = yid->wcd->data_size;
 		}
-		if (header_len >= 13)
-		{
+		if (header_len >= 13) {
 			yid->wcd->packet_type = yid->rxqueue[pos++];
 			yid->wcd->timestamp = yahoo_get32(yid->rxqueue + pos);
@@ -3303,5 +2886,6 @@
 	begin = pos;
 	pos += yid->wcd->to_read;
-	if (pos > yid->rxlen) pos = yid->rxlen;
+	if (pos > yid->rxlen)
+		pos = yid->rxlen;
 
 	/* if it is not an image then make sure we have the whole packet */
@@ -3316,81 +2900,82 @@
 
 	DEBUG_MSG(("packet type %.2X, data length %d", yid->wcd->packet_type,
-		yid->wcd->data_size));
+			yid->wcd->data_size));
 
 	/* find out what kind of packet we got */
-	switch (yid->wcd->packet_type)
-	{
-		case 0x00:
-			/* user requests to view webcam (uploading) */
-			if (yid->wcd->data_size &&
-				yid->wcm->direction == YAHOO_WEBCAM_UPLOAD) {
-				end = begin;
-				while (end <= yid->rxlen &&
-					yid->rxqueue[end++] != 13);
-				if (end > begin)
-				{
-					who = y_memdup(yid->rxqueue + begin, end - begin);
-					who[end - begin - 1] = 0;
-					YAHOO_CALLBACK(ext_yahoo_webcam_viewer)(yd->client_id, who + 2, 2);
-					FREE(who);
-				}
-			}
-
-			if (yid->wcm->direction == YAHOO_WEBCAM_DOWNLOAD) {
-				/* timestamp/status field */
-				/* 0 = declined viewing permission */
-				/* 1 = accepted viewing permission */
-				if (yid->wcd->timestamp == 0) {
-					YAHOO_CALLBACK(ext_yahoo_webcam_closed)(yd->client_id, yid->wcm->user, 3);
-				}
-			}
-			break;
-		case 0x01: /* status packets?? */
-			/* timestamp contains status info */
-			/* 00 00 00 01 = we have data?? */
-			break;
-		case 0x02: /* image data */
-			YAHOO_CALLBACK(ext_yahoo_got_webcam_image)(yd->client_id, 
-					yid->wcm->user, yid->rxqueue + begin,
-					yid->wcd->data_size, pos - begin,
-					yid->wcd->timestamp);
-			break;
-		case 0x05: /* response packets when uploading */
-			if (!yid->wcd->data_size) {
-				YAHOO_CALLBACK(ext_yahoo_webcam_data_request)(yd->client_id, yid->wcd->timestamp);
-			}
-			break;
-		case 0x07: /* connection is closing */
-			switch(reason)
-			{
-				case 0x01: /* user closed connection */
-					closed = 1;
-					break;
-				case 0x0F: /* user cancelled permission */
-					closed = 2;
-					break;
-			}
-			YAHOO_CALLBACK(ext_yahoo_webcam_closed)(yd->client_id, yid->wcm->user, closed);
-			break;
-		case 0x0C: /* user connected */
-		case 0x0D: /* user disconnected */
-			if (yid->wcd->data_size) {
-				who = y_memdup(yid->rxqueue + begin, pos - begin + 1);
-				who[pos - begin] = 0;
-				if (yid->wcd->packet_type == 0x0C)
-					connect=1;
-				else
-					connect=0;
-				YAHOO_CALLBACK(ext_yahoo_webcam_viewer)(yd->client_id, who, connect);
+	switch (yid->wcd->packet_type) {
+	case 0x00:
+		/* user requests to view webcam (uploading) */
+		if (yid->wcd->data_size &&
+			yid->wcm->direction == YAHOO_WEBCAM_UPLOAD) {
+			end = begin;
+			while (end <= yid->rxlen && yid->rxqueue[end++] != 13) ;
+			if (end > begin) {
+				who = y_memdup(yid->rxqueue + begin,
+					end - begin);
+				who[end - begin - 1] = 0;
+				YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->
+					client_id, who + 2, 2);
 				FREE(who);
 			}
-			break;
-		case 0x13: /* user data */
-			/* i=user_ip (ip of the user we are viewing) */
-			/* j=user_ext_ip (external ip of the user we */
- 			/*                are viewing) */
-			break;
-		case 0x17: /* ?? */
-			break;
+		}
+
+		if (yid->wcm->direction == YAHOO_WEBCAM_DOWNLOAD) {
+			/* timestamp/status field */
+			/* 0 = declined viewing permission */
+			/* 1 = accepted viewing permission */
+			if (yid->wcd->timestamp == 0) {
+				YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->
+					client_id, yid->wcm->user, 3);
+			}
+		}
+		break;
+	case 0x01:		/* status packets?? */
+		/* timestamp contains status info */
+		/* 00 00 00 01 = we have data?? */
+		break;
+	case 0x02:		/* image data */
+		YAHOO_CALLBACK(ext_yahoo_got_webcam_image) (yd->client_id,
+			yid->wcm->user, yid->rxqueue + begin,
+			yid->wcd->data_size, pos - begin, yid->wcd->timestamp);
+		break;
+	case 0x05:		/* response packets when uploading */
+		if (!yid->wcd->data_size) {
+			YAHOO_CALLBACK(ext_yahoo_webcam_data_request) (yd->
+				client_id, yid->wcd->timestamp);
+		}
+		break;
+	case 0x07:		/* connection is closing */
+		switch (reason) {
+		case 0x01:	/* user closed connection */
+			closed = 1;
+			break;
+		case 0x0F:	/* user cancelled permission */
+			closed = 2;
+			break;
+		}
+		YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->client_id,
+			yid->wcm->user, closed);
+		break;
+	case 0x0C:		/* user connected */
+	case 0x0D:		/* user disconnected */
+		if (yid->wcd->data_size) {
+			who = y_memdup(yid->rxqueue + begin, pos - begin + 1);
+			who[pos - begin] = 0;
+			if (yid->wcd->packet_type == 0x0C)
+				connect = 1;
+			else
+				connect = 0;
+			YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->client_id,
+				who, connect);
+			FREE(who);
+		}
+		break;
+	case 0x13:		/* user data */
+		/* i=user_ip (ip of the user we are viewing) */
+		/* j=user_ext_ip (external ip of the user we */
+		/*                are viewing) */
+		break;
+	case 0x17:		/* ?? */
+		break;
 	}
 	yid->wcd->to_read -= pos - begin;
@@ -3398,9 +2983,10 @@
 	yid->rxlen -= pos;
 	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
+	if (yid->rxlen > 0) {
 		unsigned char *tmp = y_memdup(yid->rxqueue + pos, yid->rxlen);
 		FREE(yid->rxqueue);
 		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
+		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
 	} else {
 		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
@@ -3415,5 +3001,5 @@
 }
 
-int yahoo_write_ready(int id, int fd, void *data)
+int yahoo_write_ready(int id, void *fd, void *data)
 {
 	struct yahoo_input_data *yid = data;
@@ -3421,30 +3007,32 @@
 	struct data_queue *tx;
 
-	LOG(("write callback: id=%d fd=%d data=%p", id, fd, data));
-	if(!yid || !yid->txqueues || !find_conn_by_id(id))
+	LOG(("write callback: id=%d fd=%p data=%p", id, fd, data));
+	if (!yid || !yid->txqueues)
 		return -2;
-	
+
 	tx = yid->txqueues->data;
 	LOG(("writing %d bytes", tx->len));
 	len = yahoo_send_data(fd, tx->queue, MIN(1024, tx->len));
 
-	if(len == -1 && errno == EAGAIN)
+	if (len == -1 && errno == EAGAIN)
 		return 1;
 
-	if(len <= 0) {
+	if (len <= 0) {
 		int e = errno;
 		DEBUG_MSG(("len == %d (<= 0)", len));
-		while(yid->txqueues) {
-			YList *l=yid->txqueues;
+		while (yid->txqueues) {
+			YList *l = yid->txqueues;
 			tx = l->data;
 			free(tx->queue);
 			free(tx);
-			yid->txqueues = y_list_remove_link(yid->txqueues, yid->txqueues);
+			yid->txqueues =
+				y_list_remove_link(yid->txqueues,
+				yid->txqueues);
 			y_list_free_1(l);
 		}
-		LOG(("yahoo_write_ready(%d, %d) len < 0", id, fd));
-		YAHOO_CALLBACK(ext_yahoo_remove_handler)(id, yid->write_tag);
+		LOG(("yahoo_write_ready(%d, %p) len < 0", id, fd));
+		YAHOO_CALLBACK(ext_yahoo_remove_handler) (id, yid->write_tag);
 		yid->write_tag = 0;
-		errno=e;
+		errno = e;
 		return 0;
 	}
@@ -3452,21 +3040,23 @@
 
 	tx->len -= len;
-	if(tx->len > 0) {
+	if (tx->len > 0) {
 		unsigned char *tmp = y_memdup(tx->queue + len, tx->len);
 		FREE(tx->queue);
 		tx->queue = tmp;
 	} else {
-		YList *l=yid->txqueues;
+		YList *l = yid->txqueues;
 		free(tx->queue);
 		free(tx);
-		yid->txqueues = y_list_remove_link(yid->txqueues, yid->txqueues);
+		yid->txqueues =
+			y_list_remove_link(yid->txqueues, yid->txqueues);
 		y_list_free_1(l);
 		/*
-		if(!yid->txqueues) 
-			LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
-		*/
-		if(!yid->txqueues) {
-			LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
-			YAHOO_CALLBACK(ext_yahoo_remove_handler)(id, yid->write_tag);
+		   if(!yid->txqueues) 
+		   LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
+		 */
+		if (!yid->txqueues) {
+			LOG(("yahoo_write_ready(%d, %p) !txqueues", id, fd));
+			YAHOO_CALLBACK(ext_yahoo_remove_handler) (id,
+				yid->write_tag);
 			yid->write_tag = 0;
 		}
@@ -3476,5 +3066,6 @@
 }
 
-static void yahoo_process_pager_connection(struct yahoo_input_data *yid, int over)
+static void yahoo_process_pager_connection(struct yahoo_input_data *yid,
+	int over)
 {
 	struct yahoo_packet *pkt;
@@ -3482,9 +3073,9 @@
 	int id = yd->client_id;
 
-	if(over)
-		return;
-
-	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER) 
-			&& (pkt = yahoo_getdata(yid)) != NULL) {
+	if (over)
+		return;
+
+	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER)
+		&& (pkt = yahoo_getdata(yid)) != NULL) {
 
 		yahoo_packet_process(yid, pkt);
@@ -3494,15 +3085,13 @@
 }
 
-static void yahoo_process_ft_connection(struct yahoo_input_data *yid, int over)
-{
-}
-
-static void yahoo_process_chatcat_connection(struct yahoo_input_data *yid, int over)
-{
-	if(over)
-		return;
-
-	if (strstr((char*)yid->rxqueue+(yid->rxlen-20), "</content>")) {
-		YAHOO_CALLBACK(ext_yahoo_chat_cat_xml)(yid->yd->client_id, (char*)yid->rxqueue);
+static void yahoo_process_chatcat_connection(struct yahoo_input_data *yid,
+	int over)
+{
+	if (over)
+		return;
+
+	if (strstr((char *)yid->rxqueue + (yid->rxlen - 20), "</content>")) {
+		YAHOO_CALLBACK(ext_yahoo_chat_cat_xml) (yid->yd->client_id,
+			(char *)yid->rxqueue);
 	}
 }
